//DCC Serial Function Decoder for MP3 sound module by Nagoden.
//Based on Nicolas's sketch http://blog.nicolas.cx .
//This sketch is refer to a Libraries  "NmraDcc"  and  a sample "Decoder_17LED_1Function".
// Yaasan's Headlight Decoder decoder also I have to reference.
// http://desktopstation.net/index_jp.html
//
#include <NmraDcc.h>
#include <SoftwareSerial.h>
//ソフトウエアシリアルの設定　
//SmileDecoderのA5（19）とA4（18）に割り当て　
//ピンがあいているD5(5),D6(6)でもよさそう
//
// DSDCCFunctionDecoder_serial_03
// ファンクションOFFの時に出力
// F0,F1は設定なし
// F14 と F15はボリューム調整
//

SoftwareSerial mySerial(19, 18); // RX, TX

int tim_delay = 500;

//使用クラスの宣言
NmraDcc  Dcc ;
DCC_MSG  Packet ;

//デフォルトのアドレスは３
#define Decoder_Address 3

//ファンクションの変数
uint8_t fn_bit_f0 = 0;
uint8_t fn_bit_f1 = 0;
uint8_t fn_bit_f2 = 0;
uint8_t fn_bit_f3 = 0;
uint8_t fn_bit_f4 = 0;
uint8_t fn_bit_f5 = 0;
uint8_t fn_bit_f6 = 0;
uint8_t fn_bit_f7 = 0;
uint8_t fn_bit_f8 = 0;
uint8_t fn_bit_f9 = 0;
uint8_t fn_bit_f10 = 0;
uint8_t fn_bit_f11 = 0;
uint8_t fn_bit_f12 = 0;
uint8_t fn_bit_f13 = 0;
uint8_t fn_bit_f14 = 0;
uint8_t fn_bit_f15 = 0;
uint8_t fn_bit_f16 = 0;
uint8_t fn_bit_f17 = 0;
uint8_t fn_bit_f18 = 0;
uint8_t fn_bit_f19 = 0;
uint8_t fn_bit_f20 = 0;
uint8_t fn_bit_f21 = 0;
uint8_t fn_bit_f22 = 0;
uint8_t fn_bit_f23 = 0;
uint8_t fn_bit_f24 = 0;
uint8_t fn_bit_f25 = 0;
uint8_t fn_bit_f26 = 0;
uint8_t fn_bit_f27 = 0;
uint8_t fn_bit_f28 = 0;

uint8_t volume = 255;

struct CVPair{
  uint16_t  CV;
  uint8_t   Value;
};
//CVのデフォルト値
CVPair FactoryDefaultCVs [] ={
  {CV_MULTIFUNCTION_PRIMARY_ADDRESS, Decoder_Address},  //CV1
  {CV_ACCESSORY_DECODER_ADDRESS_MSB, 0},                //CV9 
  {CV_MULTIFUNCTION_EXTENDED_ADDRESS_MSB, 0},           //CV17
  {CV_MULTIFUNCTION_EXTENDED_ADDRESS_LSB, 0},           //CV18
  {CV_29_CONFIG, 2 },                                   //CV29  28/128step, 2 Digit Address, non-Anlog, forword
};
  uint8_t FactoryDefaultCVIndex = 0;


void notifyCVResetFactoryDefault(){
  //CVをデフォルトにリセット
  Serial.println("Start of reset....");

    FactoryDefaultCVIndex = sizeof(FactoryDefaultCVs) / sizeof(CVPair);
    Serial.println("CV   Value");
    for (int j=0; j < FactoryDefaultCVIndex; j++ ){
      Dcc.setCV( FactoryDefaultCVs[j].CV, FactoryDefaultCVs[j].Value);
      Serial.print(FactoryDefaultCVs[j].CV);
      Serial.print("    ");
      Serial.println(FactoryDefaultCVs[j].Value);
    }
    delay(1000);  //typical CV programming sends the same command multiple times - specially since we dont ACK. so ignore them by delaying
    Serial.println("reset complete!");
};

//{
//  // Make FactoryDefaultCVIndex non-zero and equal to num CV's to be reset 
//  // to flag to the loop() function that a reset to Factory Defaults needs to be done
//  FactoryDefaultCVIndex = sizeof(FactoryDefaultCVs)/sizeof(CVPair);
//};
extern void     notifyCVChange( uint16_t CV, uint8_t Value){
   //CVが変更されたときのメッセージ
    Serial.println("CV   Value     Canged CV Value");
    Serial.print(CV);
    Serial.print("    ");
    Serial.println(Value);
};

void setup(){
  //デバッグ用シリアル通信開始
  Serial.begin(115200);
  
  // ソフトウエアシリアル通信レートセット:
  mySerial.begin(300);

  // Setup which External Interrupt, the Pin it's associated with that we're using and enable the Pull-Up 
  Dcc.pin(0, 2, 0);
  // Call the main DCC Init function to enable the DCC Receiver
  Dcc.init( MAN_ID_DIY, 100, FLAGS_MY_ADDRESS_ONLY, 0 );
}

void loop(){
  // You MUST call the NmraDcc.process() method frequently from the Arduino loop() function for correct library operation
  Dcc.process();
  if( FactoryDefaultCVIndex && Dcc.isSetCVReady()){
    FactoryDefaultCVIndex--; // Decrement first as initially it is the size of the array 
    Dcc.setCV( FactoryDefaultCVs[FactoryDefaultCVIndex].CV, FactoryDefaultCVs[FactoryDefaultCVIndex].Value);
  }

}

//ファンクション信号受信のイベント
//FN_0_4とFN_5_8は常時イベント発生（DCS50KはF8まで）
//FN_9_12以降はFUNCTIONボタンが押されたときにイベント発生
extern void notifyDccFunc( uint16_t Addr, FN_GROUP FuncGrp, uint8_t FuncState) {
  switch(FuncGrp) {
    case FN_0_4:
//       Serial.print("FN_0_4  ");
//       Serial.print(" ");
//       Serial.println(FuncState );  
//       (FuncState & FN_BIT_00) = 16
         if  ((FuncState & FN_BIT_00) == 16){
            if (fn_bit_f0 == 0){
              fn_bit_f0 = 1;
              Serial.println("F0 : On");
//              mySerial.print("F00;");
              delay(380);
             }
         }    
         else{
            if (fn_bit_f0 == 1) {
              fn_bit_f0 = 0;
              Serial.println("F0 : Off");
//              mySerial.print("F00;");
              delay(380);
             }
         }
//       (FuncState & FN_BIT_01) = 1
         if  ((FuncState & FN_BIT_01) == 1){
            if (fn_bit_f1 == 0) {
              fn_bit_f1 = 1;
              Serial.println("F1 : On");
//              mySerial.print("F01;");
              delay(380);
             }
         }    
         else{
            if (fn_bit_f1 == 1){
              fn_bit_f1 = 0;
              Serial.println("F1 : Off");
//              mySerial.print("F01;");
              delay(380);
             }
         }
//       (FuncState & FN_BIT_02) = 2
         if  ((FuncState & FN_BIT_02) == 2) {
            if (fn_bit_f2 == 0) {
              fn_bit_f2 = 1;
              Serial.println("F2 : On");
              mySerial.print("F02;");
              delay(360);
             }
         }    
         else {
            if (fn_bit_f2 == 1) {
              fn_bit_f2 = 0;
              Serial.println("F2 : Off");
//              F2のOFFは出力していない              
//              mySerial.print("F02;");
             }
         }
//       (FuncState & FN_BIT_03) = 4
         if  ((FuncState & FN_BIT_03) == 4){
            if (fn_bit_f3 == 0) {
              fn_bit_f3 = 1;
//              Serial.println("F3 : On");
//              mySerial.print("F03;");
//              delay(360);
             }
         }    
         else {
            if (fn_bit_f3 == 1){
              fn_bit_f3 = 0;
              Serial.println("F3 : Off");
              mySerial.print("F03;");
              delay(360);
             }
         }
//       (FuncState & FN_BIT_04) = 8
         if ((FuncState & FN_BIT_04) == 8){
            if (fn_bit_f4 == 0) {
              fn_bit_f4 = 1;
//            Serial.println("F4 : On");
//              mySerial.print("F04;");
//              delay(360);
             }
         }    
         else{
            if (fn_bit_f4 == 1){
              fn_bit_f4 = 0;
              Serial.println("F4 : Off");
              mySerial.print("F04;");
              delay(360);
             }
         }
      break;
      
    case FN_5_8:
//       Serial.print("FN_5_8  ");
//       Serial.print(" ");
//       Serial.println(FuncState );  
//       (FuncState & FN_BIT_05) = 1
         if  ((FuncState & FN_BIT_05) == 1){
            if (fn_bit_f5 == 0) {
              fn_bit_f5 = 1;
//              Serial.println("F5 : On");
//              mySerial.print("F05;");
//              delay(360);
             }
         }    
         else{
            if (fn_bit_f5 == 1){
              fn_bit_f5 = 0;
              Serial.println("F5 : Off");
              mySerial.print("F05;");
              delay(360);
             }
         }
//       (FuncState & FN_BIT_06) = 2
         if  ((FuncState & FN_BIT_06) == 2) {
            if (fn_bit_f6 == 0) {
              fn_bit_f6 = 1;
//              Serial.println("F6 : On");
//              mySerial.print("F06;");
//              delay(360);
             }
         }    
         else {
            if (fn_bit_f6 == 1) {
              fn_bit_f6 = 0;
              Serial.println("F6 : Off");
              mySerial.print("F06;");
              delay(360);
             }
         }
//       (FuncState & FN_BIT_07) = 4
         if  ((FuncState & FN_BIT_07) == 4) {
            if (fn_bit_f7 == 0) {
              fn_bit_f7 = 1;
//              Serial.println("F7 : On");
//              mySerial.print("F07;");
//              delay(360);
             }
         }    
         else {
            if (fn_bit_f7 == 1) {
              fn_bit_f7 = 0;
              Serial.println("F7 : Off");
              mySerial.print("F07;");
              delay(360);
             }
         }
//       (FuncState & FN_BIT_08) = 8
         if  ((FuncState & FN_BIT_08) == 8){
            if (fn_bit_f8 == 0){
              fn_bit_f8 = 1;
//              Serial.println("F8 : On");
//              mySerial.print("F08;");
//              delay(360);
             }
         }    
         else{
            if (fn_bit_f8 == 1){
              fn_bit_f8 = 0;
              Serial.println("F8 : Off");
              mySerial.print("F08;");
              delay(360);
             }
         }

      break;
      
    case FN_9_12:
//       Serial.print("FN_9_12  ");
//       Serial.print(" ");
//       Serial.println(FuncState );  
//       (FuncState & FN_BIT_09) = 1
         if  ((FuncState & FN_BIT_09) == 1) {
            if (fn_bit_f9 == 0) {
              fn_bit_f9 = 1;
//              Serial.println("F9 : On");
//              mySerial.print("F09;");
//              delay(330);
             }
         }    
         else{
            if (fn_bit_f9 == 1) {
              fn_bit_f9 = 0;
              Serial.println("F9 : Off");
              mySerial.print("F09;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_10) = 2
         if  ((FuncState & FN_BIT_10) == 2) {
            if (fn_bit_f10 == 0) {
              fn_bit_f10 = 1;
//              Serial.println("F10 : On");
//              mySerial.print("F10;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f10 == 1) {
              fn_bit_f10 = 0;
              Serial.println("F10 : Off");
              mySerial.print("F10;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_11) = 4
         if  ((FuncState & FN_BIT_11) == 4) {
            if (fn_bit_f11 == 0) {
              fn_bit_f11 = 1;
//              Serial.println("F11 : On");
//              mySerial.print("F11;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f11 == 1) {
              fn_bit_f11 = 0;
              Serial.println("F11 : Off");
              mySerial.print("F11;");
              delay(330);
             }
         }

//       (FuncState & FN_BIT_12) = 8
         if  ((FuncState & FN_BIT_12) == 8) {
            if (fn_bit_f12 == 0) {
              fn_bit_f12 = 1;
              Serial.println("F12 : On");
              mySerial.print("F12;");
              delay(330);
             }
         }    
         else {
            if (fn_bit_f12 == 1) {
              fn_bit_f12 = 0;
//              Serial.println("F12 : Off");
//              mySerial.print("F12;");
//              delay(330);
             }
         }

      break;

    case FN_13_20:
//       Serial.print("FN_13_20  ");
//       Serial.print(" ");
//       Serial.println(FuncState );
//       (FuncState & FN_BIT_13) = 1
         if  ((FuncState & FN_BIT_13) == 1) {
            if (fn_bit_f13 == 0) {
              fn_bit_f13 = 1;
              Serial.println("F13 : On");
              mySerial.print("F13;");
              delay(330);
             }
         }    
         else {
            if (fn_bit_f13 == 1) {
              fn_bit_f13 = 0;
//              Serial.println("F13 : Off");
//              mySerial.print("F13;");
//              delay(330);
             }
         }
//       (FuncState & FN_BIT_14) = 2
         if  ((FuncState & FN_BIT_14) == 2) {
            if (fn_bit_f14 == 0) {
              fn_bit_f14 = 1;
//              Serial.println("F14 : On");
//              mySerial.print("F14;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f14 == 1) {
              fn_bit_f14 = 0;
//              Serial.println("F14 : Off");
//              mySerial.print("F14;");
//              delay(330);
//            Volume Down     
              volume += 8;              
              Serial.print("volume +8:");
              Serial.println(volume,HEX);
              mySerial.print("V");
              mySerial.print(volume,HEX);
              mySerial.print(";");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_15) = 4
         if  ((FuncState & FN_BIT_15) == 4) {
            if (fn_bit_f15 == 0) {
              fn_bit_f15 = 1;
//              Serial.println("F15 : On");
//              mySerial.print("F15;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f15 == 1) {
              fn_bit_f15 = 0;
//              Serial.println("F15 : Off");
//              mySerial.print("F15;");
//              delay(330);
//            Volume UP     
              volume -= 8;
              Serial.print("volume -8:");
              Serial.println(volume,HEX);
              mySerial.print("V");
              mySerial.print(volume,HEX);
              mySerial.print(";");
              delay(330);
             }
         }

//       (FuncState & FN_BIT_16) = 8
         if  ((FuncState & FN_BIT_16) == 8) {
            if (fn_bit_f16 == 0) {
              fn_bit_f16 = 1;
//              Serial.println("F16 : On");
//              mySerial.print("F16;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f16 == 1) {
              fn_bit_f16 = 0;
              Serial.println("F16 : Off");
              mySerial.print("F16;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_17) = 16
         if  ((FuncState & FN_BIT_17) == 16) {
            if (fn_bit_f17 == 0) {
              fn_bit_f17 = 1;
//              Serial.println("F17 : On");
//              mySerial.print("F17;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f17 == 1) {
              fn_bit_f17 = 0;
              Serial.println("F17 : Off");
              mySerial.print("F17;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_18) = 32
         if  ((FuncState & FN_BIT_18) == 32) {
            if (fn_bit_f18 == 0) {
              fn_bit_f18 = 1;
//              Serial.println("F18 : On");
//              mySerial.print("F18;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f18 == 1) {
              fn_bit_f18 = 0;
              Serial.println("F18 : Off");
              mySerial.print("F18;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_19) = 64
         if  ((FuncState & FN_BIT_19) == 64) {
            if (fn_bit_f19 == 0) {
              fn_bit_f19 = 1;
//              Serial.println("F19 : On");
//              mySerial.print("F19;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f19 == 1) {
              fn_bit_f19 = 0;
              Serial.println("F19 : Off");
              mySerial.print("F19;");
              delay(330);
             }
         }

 //       (FuncState & FN_BIT_20) = 128
         if  ((FuncState & FN_BIT_20) == 128) {
            if (fn_bit_f20 == 0) {
              fn_bit_f20 = 1;
//              Serial.println("F20 : On");
//              mySerial.print("F20;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f20 == 1) {
              fn_bit_f20 = 0;
              Serial.println("F20 : Off");
              mySerial.print("F20;");
              delay(330);
             }
         }
      break;
      
    case FN_21_28:
//       Serial.print("FN_21_28  ");
//       Serial.print(" ");
//       Serial.println(FuncState );
//       (FuncState & FN_BIT_21) = 1
         if  ((FuncState & FN_BIT_21) == 1) {
            if (fn_bit_f21 == 0) {
              fn_bit_f21 = 1;
//              Serial.println("F21 : On");
//              mySerial.print("F21;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f21 == 1) {
              fn_bit_f21 = 0;
              Serial.println("F21 : Off");
              mySerial.print("F21;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_22) = 2
         if  ((FuncState & FN_BIT_22) == 2) {
            if (fn_bit_f22 == 0) {
              fn_bit_f22 = 1;
//              Serial.println("F22 : On");
//              mySerial.print("F22;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f22 == 1) {
              fn_bit_f22 = 0;
              Serial.println("F22 : Off");
              mySerial.print("F22;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_23) = 4
         if  ((FuncState & FN_BIT_23) == 4) {
            if (fn_bit_f23 == 0) {
              fn_bit_f23 = 1;
//              Serial.println("F23 : On");
//              mySerial.print("F23;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f23 == 1) {
              fn_bit_f23 = 0;
              Serial.println("F23 : Off");
              mySerial.print("F23;");
              delay(330);
             }
         }

//       (FuncState & FN_BIT_24) = 8
         if  ((FuncState & FN_BIT_24) == 8) {
            if (fn_bit_f24 == 0) {
              fn_bit_f24 = 1;
//              Serial.println("F24 : On");
//              mySerial.print("F24;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f24 == 1) {
              fn_bit_f24 = 0;
              Serial.println("F24 : Off");
              mySerial.print("F24");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_25) = 16
         if  ((FuncState & FN_BIT_25) == 16) {
            if (fn_bit_f25 == 0) {
              fn_bit_f25 = 1;
//              Serial.println("F25 : On");
//              mySerial.print("F25;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f25 == 1) {
              fn_bit_f25 = 0;
              Serial.println("F25 : Off");
              mySerial.print("F25;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_26) = 32
         if  ((FuncState & FN_BIT_26) == 32) {
            if (fn_bit_f26 == 0) {
              fn_bit_f26 = 1;
//              Serial.println("F26 : On");
//              mySerial.print("F26");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f26 == 1) {
              fn_bit_f26 = 0;
              Serial.println("F26 : Off");
              mySerial.print("F26;");
              delay(330);
             }
         }
//       (FuncState & FN_BIT_27) = 64
         if  ((FuncState & FN_BIT_27) == 64) {
            if (fn_bit_f27 == 0) {
              fn_bit_f27 = 1;
//              Serial.println("F27 : On");
//              mySerial.print("F27;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f27 == 1) {
              fn_bit_f27 = 0;
              Serial.println("F27 : Off");
              mySerial.print("F27;");
              delay(330);
             }
         }

 //       (FuncState & FN_BIT_28) = 128
         if  ((FuncState & FN_BIT_28) == 128) {
            if (fn_bit_f28 == 0) {
              fn_bit_f28 = 1;
//              Serial.println("F28 : On");
//              mySerial.print("F28;");
//              delay(330);
             }
         }    
         else {
            if (fn_bit_f28 == 1) {
              fn_bit_f28 = 0;
              Serial.println("F28 : Off");
              mySerial.print("F28;");
              delay(330);
             }
         }
      break;
  }
}

